
/*
 * @bCR
 *
 * Licensed Materials-Property of IBM, 5697-EAS
 * (C)Copyright IBM Corp 2002
 * (C)Copyright Tivoli Systems, an IBM Co 2002
 * All Rights Reserved
 * US Government Users Restricted Rights
 * Use, duplication, or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp
 *
 * @eCR
 */

/*
 * Component Name: EIF
 *           File: ./include/tec_eeif.h
 *
 * : 12/12/07 14:03:41 $
 *
 * : src/event_delivery/include/tec_eeif.h, tec_eif, tec_3.9.0 $
 *
 * : 1.26.1.12 $
 *
 */

/*
 * Description:
 *    Public header file for EEIF interface.  This file should contain all
 *    definitions and prototypes needed to use the EIF library.
 *    Conversely, it should not contain any thing that is not intended to
 *    be public.
 *
 * Purpose:
 *
 * Usage:
 *
 * Dependencies:
 *
 */

/*
 * Change History:
 *   author   date      description
 *   xxxxxxx  05/01/02  added this section
 *
 */

#ifndef TEC_EEIF_H
#define TEC_EEIF_H

#ifndef EXTERN_DECL
#  if defined(__cplusplus)
#     define EXTERN_DECL(entry, args) extern "C" entry args
#  elif defined(__STDC__) || defined(STDC_SRC_COMPATIBLE)  || defined(__EXTENDED__)
#     define EXTERN_DECL(entry, args) extern entry args
#  else
#     define EXTERN_DECL(entry, args) extern entry()
#  endif
#endif

#ifndef EXTERN_VAR
#  if defined(__cplusplus)
#     define EXTERN_VAR(entry) extern "C" entry
#  elif defined(__STDC__) || defined(STDC_SRC_COMPATIBLE)  || defined(__EXTENDED__)
#     define EXTERN_VAR(entry) extern entry
#  else
#     define EXTERN_VAR(entry) extern entry
#  endif
#endif


#ifndef PC
#	include <sys/time.h>
#endif

/*
 *  Backward comapatibility
 */
#define EVENT_MAX_SIZE                  "EventMaxSize"
#define FILTER                          "Filter:"
#define FILTER_CACHE                    "FilterCache:"
#define TECAD_FILTERMODE                "FilterMode"
#define PREFILTER                       "PreFilter:"
#define TECAD_PFLTMODE                  "PreFilterMode"
#define TECAD_EVENT_TO_CATCH            "NumEventsToCatchUp"
#define VERSION_3_SERVER_ENCODING       "Pre37ServerEncoding"
#define VERSION_3_SERVER_COMPATIBILITY  "Pre37Server"

#define FILE_LEN              256
#define WORKBUF_SIZE          4096
#define MAX_EVENT_LOGS_MON    60

#define KWD_FILTER                FILTER
#define KWD_FILTER_CACHE          FILTER_CACHE
#define KWD_TECAD_FILTERMODE      TECAD_FILTERMODE
#define KWD_TECAD_PFLTMODE        TECAD_PFLTMODE
#define KWD_PREFILTER             PREFILTER
#define KWD_BUFFER_EVENT_MAX_SIZE "BufEvtMaxSize"
#define KWD_BUFFER_SHRINK_SIZE    "BufEvtShrinkSize"
#define KWD_BUFFER_FLUSH_RATE     "BufferFlushRate"
#define KWD_BUFFER_RD_BLK_LEN     "BufEvtRdBlkLen"
#define KWD_BUFFER_EVENT_PATH     "BufEvtPath"
#define KWD_BUFFER_EVENTS         "BufferEvents"
#define KWD_BUFFER_EVENTS_LIMIT   "BufferEventsLimit" /* not supported */
#define KWD_EVENT_MAX_SIZE        "EventMaxSize"
#define KWD_SERVER_LOCATION       "ServerLocation"
#define KWD_SERVER_PORT           "ServerPort"
#define KWD_SERVER			       "Server"
#define KWD_TEST_MODE             "TestMode"
#define KWD_NO_UTF8_CONVERSION    "NO_UTF8_CONVERSION"
#define KWD_RETRY_INTERVAL        "RetryInterval"
#define KWD_RETRY_COUNT           "RetryCount"
#define KWD_TRANSPORTLIST         "TransportList"
#define KWD_USE_STATE_CORR        "UseStateCorrelation"
#define KWD_STATE_CORR_URL        "StateCorrelationConfigURL"
#define KWD_MAX_PACKET_SIZE       "MaxPacketSize"
#define KWD_CONNECTION_MODE       "ConnectionMode"
#define KWD_FROM_CCSID            "FromCCSID"
#define KWD_SERVER_CCSID          "ServerCCSID"
#define KWD_ED_DIAG               "ed_diag_config_file"
#define KWD_V3_SVR_ENCODING       "Pre37ServerEncoding"
#define KWD_V3_SVR_COMPATIBILITY  "Pre37Server"
#define KWD_USE_DEFAULT_LOCATION  "UseDefaultLocation"
#define KWD_OPTION_PORT_UNAVAIL   "OptionPortNotAvailable"
#define KWD_ACTIVE_CONNECTIONS    "ActiveConnections"
#define KWD_ACTIVE_CONN_SAFETY    "ActiveConnectionsSafety"
#define KWD_CONNECTIONS_QUEUED    "ConnectionsQueued"
#define KWD_POLL_TIMEOUT          "PollTimeout"
#define KWD_POLL_TIMEOUT_U        "PollTimeout_u"
#define KWD_GETPORT_TIMEOUT_SECONDS       "getport_timeout_seconds"
#define KWD_GETPORT_TIMEOUT_USEC          "getport_timeout_usec"
#define KWD_GETPORT_TOTAL_TIMEOUT_SECONDS "getport_total_timeout_seconds"
#define KWD_GETPORT_TOTAL_TIMEOUT_USEC    "getport_total_timeout_usec"
#define KWD_EIPC_VERIFY_PORTMAPPER        "eipc_verify_portmapper"

/* 179483 keywords */
#define KWD_SEND_RTSS        "SendRTSS"
#define KWD_RTSS_TIMEOUT     "TimeoutRTSS"
#define KWD_RESPECT_RTSS     "RespectRTSS"
#define KWD_CTS_SERVER_PORT  "ServerPortCTS"
#define KWD_PORTMAP_REMEMBER "PORTMAPPER_REMEMBER_PORT"


#define TRANSPORT_SOCKET_STR      "SOCKET"
#define TRANSPORT_FWK_STR         "TME"
#define TRANSPORT_LCF_STR         "LCF"

#define TRANSPORT_FILE_STR        "FILE"
#define TRANSPORT_MQ_STR          "MQ"
#define TRANSPORT_CONSOLE_STR     "CONSOLE"
#define TRANSPORT_IPC_STR         "IPC"


/* setting tec_errno */
#define ED_ERR_BASE	                  820
#define ED_ERR_HANDLE_ALLOC 				ED_ERR_BASE+1
#define ED_ERR_PROCESSES 					ED_ERR_BASE+2
#define ED_ERR_CACHE_CONTROLLER 			ED_ERR_BASE+3
#define ED_ERR_COMMON_AGENT 				ED_ERR_BASE+4
#define ED_ERR_TRANSPORT_LIST 			ED_ERR_BASE+5
#define ED_ERR_TRANSPORT_CONTROLLER 	ED_ERR_BASE+6
#define ED_ERR_JVM 							ED_ERR_BASE+7
#define ED_ERR_STATE_CORRELATOR 			ED_ERR_BASE+8

/*
 * All TEC events must end with TECAD_EVENT_DELIMITER
 */
#define TECAD_EVENT_DELIMITER			"END\n\001"
#define TECAD_EVENT_DELIMITER_LEN	5
#define TECAD_EVENT_END_CHAR			'\001'

/*
 * Types of event filters.
 *
 * FILTER_EVENT_TYPE         Filters events into/from being sent to the server
 * FILTER_EVENT_CACHE_TYPE   Filters events into/from being buffered if server
 *                           is unavailable.
 */
typedef enum
{
	FILTER_EVENT_TYPE,
	FILTER_EVENT_CACHE_TYPE
}
FilterType;

/*
 * Types of connections to the TEC Server.
 *
 * connection_less      A new connection is opened and closed for each event
 * connection_oriented  One open connection is maintained for sending all events
 * use_default          Use the default value specified in the EIF *.conf file
 *                      with the "ConnectionMode" setting.
 */
typedef enum
{
	connection_less,
	connection_oriented,
	use_default
}
tec_delivery;

typedef enum
{
	submission,
	reception
}
delivery_mode;

typedef void *tec_handle_t;


/*
 * Global variables.
 */
EXTERN_VAR(int tec_errno);
EXTERN_VAR(int TECAD_no_connection);

/*
 * Global functions.
 */

/*
 * To initialize configuration parameters from the given configuration file
 * (typically named with a .conf extension).
 */

EXTERN_DECL(int tec_agent_init, (char *));

/*
 * Retrieves the value of a given variable that was read from a configuration
 * file with tec_agent_init().
 * The second form, when used in conjunction with tec_create_handle_r(),
 * allows for multiple simultaneous configurations to exist for multiple
 * connections.
 */
EXTERN_DECL(char *tec_agent_getenv, (char *));
EXTERN_DECL(char *tec_agent_getenv_r, (tec_handle_t, char *));


/*
 * tec_create_handle
 *
 * Establishes and returns a 'handle' used for several operations, including
 * sending events to an event server.
 *
 * The create handle has different signatures allowing different paramaters
 * One form, tec_create_handle_r(), is the same as the original first
 * form, except that the first parameter is the name of a configuration file.
 * With the second form, tec_agent_init() is automatically performed internally
 * and does not need to be invoked by the calling program.  This allows the
 * information from a configuration file to be associated with a specific
 * tec_handle_t rather than being a global variable.  This, in turn, allows
 * multiple connections to each have their own configuration (e.g., a process
 * could send events to 3 different destinations and have unique buffering,
 * filtering, and other configuration set for each one).
 *
 *
 */

/*
tec_create_EIF_handle
added for 3.8 to create a handle using a config file

	cfgFile - path to config file can be NULL
	oneway - use oneway comm  0/1,
	dm - delvery mode  of type delivery_mode submission reception

tec_create_handle_r
kept from previous release

	cfgFile - path to config file can be NULL
	location - first server location
	port - port number
	oneway - use oneway comm  0/1,
	td - tec delivery of type tec_delivery
			connection_less, connection_oriented, use_default

tec_create_handle_c
added in 3.8 to create a handle with various arguments

	cfgFile - path to config file can be NULL
	location - first server location
	port - port number
	oneway - use oneway comm  0/1,
	td - tec delivery of type tec_delivery
			connection_less, connection_oriented, use_default
	dm - delvery mode  of type delivery_mode submission reception

th = tec_create_EIF_handle  (NULL,0,submission)
th = tec_create_EIF_handle  (NULL,0,reception)
th = tec_create_EIF_handle  ("cfg.conf",0,submission)
th = tec_create_EIF_handle  ("cfg.conf",1,submission)

th = tec_create_handle_c  (NULL,NULL,0,0,use_default,submission);
th = tec_create_handle_c  (NULL,localhost,0,0,use_default,reception);
th = tec_create_handle_c  ("cfg.conf",NULL,0,0,connection_oriented,submission);
th = tec_create_handle_c  ("cfg.conf","host1.com",5599,0,use_default,submission);

th = tec_create_handle  (NULL,0,0,use_default,submission);
th = tec_create_handle  (localhost,0,0,use_default,reception);
th = tec_create_handle  ("host1.com",5599,0,use_default,submission);

*/

EXTERN_DECL(tec_handle_t tec_create_EIF_handle, (char * cfgFile,
                                                 int oneway,
                                                 delivery_mode dm));

EXTERN_DECL(tec_handle_t tec_create_handle_r, (char *,
                                               char *,
                                               unsigned short,
                                               int,
                                               tec_delivery));

EXTERN_DECL(tec_handle_t tec_create_handle_c, (char *,
                                               char *,
                                               unsigned short,
                                               int,
                                               tec_delivery,
                                               delivery_mode));

#define tec_create_handle(_loc,_prt,_ow,_typ) \
			tec_create_handle_c(NULL, _loc,_prt,_ow,_typ,submission)

/*
 * Releases a handle created by tec_create_handle(), closes any open
 * communication channels and frees associated memory.
 */
EXTERN_DECL(void tec_destroy_handle, (tec_handle_t));

/*
 * Destroys the handle to the event server created by tec_create_handle, tec_create_handle_c, 
 * tec_create_EIF_handle, and tec_create_handle_r and closes any established connections.  
 * The second parameter indicates that the cache should be flushed before the handle is destroyed.
 * 
 * max_seconds_to_wait   < 0 - Wait forever or until cache is emptied.  If the server is down 
 *                             this API call will not return.
 *                       = 0 - Send events from the cache while the connection remains up.  
 *                             It could take a while to send all the events if the cache is large.
 *                             The API call will return as soon as the cache is empty or 
 *                             the connection to the TEC Server is lost.  
 *                       > 0 - Stop emptying the cache after the specified number of seconds.
 *                             The API call will return as soon as the cache is empty or
 *                             after the specified number of seconds.
 */
EXTERN_DECL(void tec_destroy_handle_delay, (tec_handle_t, int));

/*
 * Sends the given event string to the event server.
 */
EXTERN_DECL(long tec_put_event, (tec_handle_t, char *));


typedef int (*tec_event_callback) (tec_handle_t h, unsigned char *msg,long msg_length);

/*
 * Receives event from eif
 */

EXTERN_DECL(int tec_register_callback, (tec_handle_t,tec_event_callback));

EXTERN_DECL(long tec_get_event, (tec_handle_t, unsigned char **event_message));

EXTERN_DECL (int ed_commit, (tec_handle_t));

/*
 * Converts event message from UTF8 to the codeset specified by the Pre37ServerEncoding keyword.
 * If Pre37Server=NO or Pre37ServerEncoding is not specified, converts event message from UTF8
 * to the codeset of the current operating system locale.
 *
 * The first parameter is the EIF handle
 * The second parameter is the original event message in UTF8
 * The third parameter is the event message after conversion to the local codeset
 *
 * The return value is the length of the event message after conversion to the local codeset
 */
EXTERN_DECL(long tec_to_local_encoding, (tec_handle_t, unsigned char *message, unsigned char **local_message));

/* Using HANDLE as the platform independent name file handle/descriptor. */
#ifdef WIN32
#	include <windows.h>
#else
#	define HANDLE int
#  define INVALID_HANDLE_VALUE -1
#endif

/*
 * Returns the size of the buffer file in bytes.  The buffer file contains
 * events that could not be sent to the event server when they were passed to
 * tec_put_event().
 * If the second parameter (buffer file name) is NULL, the buffer file specified
 * in the configuration file is used.
 * If the third parameter (file handle/descriptor pointer) is not NULL, an open
 * file handle or descriptor to the buffer file is returned.  The caller must
 * close this handle.
 */
EXTERN_DECL(long tec_event_buffer_size, (tec_handle_t, char *, HANDLE *));

/*
 sec
 nansec     500000  1/2 sec
*/
EXTERN_DECL(int ed_sleep, (long, long));


EXTERN_DECL(char *ed_scan_get_n, (char *packet, long index, long packet_len, long *str_len));
EXTERN_DECL(long ed_scan_n, (char *packet, long packet_len));
EXTERN_DECL(long ed_scan_for_n, (char *packet, long index, long packet_len, char **str, long *str_len));

#endif

