
/*
 * @bCR
 * 
 * Licensed Materials-Property of IBM, 5697-EAS
 * (C)Copyright IBM Corp 2002
 * (C)Copyright Tivoli Systems, an IBM Co 2002
 * All Rights Reserved
 * US Government Users Restricted Rights
 * Use, duplication, or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp
 * 
 * @eCR
 */

/*
 * Component Name: EIF
 *           File: ./sample/eifrcv1.c
 *
 * : 10/13/05 14:30:28 $
 *
 * : src/event_delivery/sample/eifrcv1.c, tec_eif, tec_3.9.0 $
 *
 * : 1.7 $
 *
 */

/*
 * Description:
 *      
 * Purpose:
 *      
 * Usage:
 *      
 * Dependencies:
 *      
 */

/*
 * Change History:
 *   author   date      description 
 *   xxxxxxx  05/01/02  added this section
 *      
 */

/*
 #
 # SAMPLE:
 #
 # usage of event reception
tec_get_events
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "tec_eeif.h"

#define DEFAULT_CONFIG_FILE  "configg"

tec_handle_t *th = NULL;
char *cfgFileName = NULL;

/* ------------------------------ */
void
print_events (char *events,long plen)
{
	long n;
	if (events)
	{
		int i;
		char *ev;
		long len;
		long idx = 1;

		n = ed_scan_n (events, plen);

		printf ("Package contains [%03ld] Events.\n", n);
		for (i = 0; i < n; i++, idx++)
		{
			ev =
			(char *) ed_scan_get_n ((char *) events, idx, plen, &len);

			printf ("[%03ld] [%ld] [%s]\n", idx, len, ev);
			free (ev);
		}
	}
	return;
}


/* ------------------------------ */
static int
process_events ()
{
	unsigned char *ev=NULL;
	long mlen=0;
	int rc = 0;
	short stopGetting = 0;
	int count = 0;

	printf ("event reception synchronous call .\n");
	printf ("Will loop attempting to get events...\n\n");

	while (!stopGetting)
	{
		ed_sleep (0, 50);
		ev=NULL;
		mlen = tec_get_event (th, &ev);

		if (ev && mlen)
		{
			printf ("USERAPPL====>EventReceived: [%ld]\n[%s]\n",mlen, ev);
			print_events (ev,mlen);
			free (ev);
			count++;
		}
		if (!ev && mlen)
		{
			printf ("Null event with length\n");
		}
		if (ev && !mlen)
		{
			printf ("event with ZERO length\n");
		}
	}
	return 0;

}

/*************************************** */
int
main (int argc, char *argv[])
{
	printf ("Sample: EIF Reception v1.3\n");

	if (!cfgFileName)
		cfgFileName = DEFAULT_CONFIG_FILE;

	printf ("initializing tec_agent from [%s]...\n", cfgFileName);

	if (tec_agent_init (cfgFileName) != 0)
	{
		printf ("Error tec_agent_init\n");
		return 1;
	}

	printf ("creating handle...\n");

	th=tec_create_EIF_handle (NULL,0, reception);
	if (!th)
	{
		printf ("Error tec_create_handle\n");
		return 1;
	}

	process_events();

	tec_destroy_handle (th);

	return 0;
}
