
/*
 * @bCR
 * 
 * Licensed Materials-Property of IBM, 5697-EAS
 * (C)Copyright IBM Corp 2002
 * (C)Copyright Tivoli Systems, an IBM Co 2002
 * All Rights Reserved
 * US Government Users Restricted Rights
 * Use, duplication, or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp
 * 
 * @eCR
 */

/*
 * Component Name: EIF
 *           File: ./sample/eifsend1.c
 *
 * : 5/20/02 15:07:53 $
 *
 * : src/event_delivery/sample/eifsend1.c, tec_eif, tec_3.9.0 $
 *
 * : 1.2 $
 *
 */

/*
 * Description:
 *      
 * Purpose:
 *      
 * Usage:
 *      
 * Dependencies:
 *      
 */

/*
 * Change History:
 *   author   date      description 
 *   xxxxxxx  05/01/02  added this section
 *      
 */

/* SAMPLE Send*/

#include <stdio.h>
#include <string.h>

#include "tec_eeif.h"

tec_handle_t *th = NULL;

#define MAXIMUM_INPUT_SIZE 2048

/* ------------------------------------- */
int
main (int argc, char *argv[])
{
	char *input_str;
	char cfg_file_name[256];
	int rc = 0;

#ifdef WIN32
	WSADATA wsaData;
	WSAStartup (MAKEWORD (1, 1), &wsaData);
#endif

	if (argc > 1)
		strcpy (cfg_file_name, argv[1]);
	else
	{
		printf ("Please specify a config file.\n");
		exit (1);
	}

	if (tec_agent_init (cfg_file_name) != 0)
		exit (1);					  /* Error */

   th=tec_create_EIF_handle (NULL,0, submission);
   if (!th)
   {
      printf ("Error tec_create_handle\n");
      return 1;
   }


	input_str = (char *) malloc (MAXIMUM_INPUT_SIZE + 1);
	memset (input_str, '\0', MAXIMUM_INPUT_SIZE);

	while (1)
	{
		gets (input_str);
		if (!strlen(input_str))
			break;
		printf ("Put..\n");

		rc = tec_put_event (th, input_str);

		ed_sleep(0,0);
		
		if (rc > 0)
			printf ("...sent\n");
		if (rc == 0)
			printf ("...filtered\n");
		if (rc < 0)
			printf ("...error\n");

		memset (input_str, '\0', MAXIMUM_INPUT_SIZE);
	}
	printf ("Done..\n");


	free (input_str);

	tec_destroy_handle (th);

	exit (0);
}
